Skip to content
The Things Stack documentation home
Getting Started Concepts Cloud Enterprise Integrations API Hardware
Getting Started Concepts
Cloud Enterprise
Integrations API Hardware
Get The Things Stack

    Recent searches

      Popular pages

      • Getting Started
      • Adding Gateways
      • Adding Devices
      • Payload Formatters
      • Webhooks
      • Authentication

      No results for “”.

      • Check the spelling, or try fewer or more general words.
      • Ask the community on The Things Network Forum
      • Contact support
      ↑↓ to navigate ↵ to open Esc to close

      API

      • Overview
      • Concepts
      • Reference
        • HTTP(REST)
        • gRPC
          • Application APIs
          • Application Package APIs
          • Application Pub/Sub APIs
          • Application Server APIs
          • Application Webhook APIs
          • Client APIs
          • Crypto Operations APIs
          • End Device APIs
          • Events API
          • Gateway APIs
          • Gateway Server APIs
          • Identity Server APIs
          • Join Server APIs
          • Network Operations Center APIs
          • Network Server APIs
          • Organization APIs
          • Packet Broker APIs
          • Storage Integration API
          • Tenant APIs
          • User APIs

      Events API

      Updated 4 March 2024 Edit on GitHub
      Copy page
      • View as MarkdownThis page as plain text
      • Open in ChatGPTAsk questions about this page
      • Open in ClaudeAsk questions about this page

      List of Events APIs.

      The Events service

      Method Events.Stream
      Description Stream live events, optionally with a tail of historical events (depending on server support and retention policy). Events may arrive out-of-order.
      Request type StreamEventsRequest
      Response type Stream of Event
      The HTTP API uses Content-Type: text/event-stream
      and a response body of newline-delimited JSON.
      Make sure to send Accept: text/event-stream in the request.
      HTTP bindings

      POST /api/v3/events

      Method Events.FindRelated
      Request type FindRelatedEventsRequest
      Response type FindRelatedEventsResponse
      HTTP bindings

      GET /api/v3/events/related

      Messages

      Message EntityIdentifiers

      EntityIdentifiers contains one of the possible entity identifiers.

      Restrictions:
      • Only one of application_ids, client_ids, device_ids, gateway_ids, organization_ids, user_ids can be set.
      Show object example
      {
        "application_ids": {},
        "client_ids": {},
        "device_ids": {},
        "gateway_ids": {},
        "organization_ids": {},
        "user_ids": {},
      }

      Fields:

      Field application_ids
      Type ApplicationIdentifiers
      Field client_ids
      Type ClientIdentifiers
      Field device_ids
      Type EndDeviceIdentifiers
      Field gateway_ids
      Type GatewayIdentifiers
      Field organization_ids
      Type OrganizationIdentifiers
      Field user_ids
      Type UserIdentifiers

      Message ApplicationIdentifiers

      Show object example
      {
        "application_id": "",
      }

      Fields:

      Field application_id
      Type string
      Description

      max_len: 36

      pattern: ^[a-z0-9](?:[-]?[a-z0-9]){2,}$

      Message ClientIdentifiers

      Show object example
      {
        "client_id": "",
      }

      Fields:

      Field client_id
      Type string
      Description

      max_len: 36

      pattern: ^[a-z0-9](?:[-]?[a-z0-9]){2,}$

      Message EndDeviceIdentifiers

      Show object example
      {
        "device_id": "",
        "application_ids": {},
        "dev_eui": "",
        "join_eui": "",
        "dev_addr": "",
      }

      Fields:

      Field device_id
      Type string
      Description

      max_len: 36

      pattern: ^[a-z0-9](?:[-]?[a-z0-9]){2,}$

      Field application_ids
      Type ApplicationIdentifiers
      Description

      required

      Field dev_eui
      Type bytes
      Description

      The LoRaWAN DevEUI.

      ignore_empty

      len: 8

      Field join_eui
      Type bytes
      Description

      The LoRaWAN JoinEUI (AppEUI until LoRaWAN 1.0.3 end devices).

      ignore_empty

      len: 8

      Field dev_addr
      Type bytes
      Description

      The LoRaWAN DevAddr.

      ignore_empty

      len: 4

      Message FindRelatedEventsRequest

      Show object example
      {
        "correlation_id": "",
      }

      Fields:

      Field correlation_id
      Type string
      Description

      max_len: 100

      min_len: 1

      Message FindRelatedEventsResponse

      Show object example
      {
        "events": [],
      }

      Fields:

      Field events
      Type repeated Event
      Description

      Message GatewayIdentifiers

      Show object example
      {
        "gateway_id": "",
        "eui": "",
      }

      Fields:

      Field gateway_id
      Type string
      Description

      max_len: 36

      pattern: ^[a-z0-9](?:[-]?[a-z0-9]){2,}$

      Field eui
      Type bytes
      Description

      Secondary identifier, which can only be used in specific requests.

      ignore_empty

      len: 8

      Message OrganizationIdentifiers

      Show object example
      {
        "organization_id": "",
      }

      Fields:

      Field organization_id
      Type string
      Description

      This ID shares namespace with user IDs.

      max_len: 36

      pattern: ^[a-z0-9](?:[-]?[a-z0-9]){2,}$

      Message UserIdentifiers

      Show object example
      {
        "user_id": "",
        "email": "",
      }

      Fields:

      Field user_id
      Type string
      Description

      This ID shares namespace with organization IDs.

      max_len: 36

      pattern: ^[a-z0-9](?:[-]?[a-z0-9]){1,}$

      Field email
      Type string
      Description

      Secondary identifier, which can only be used in specific requests.

      Message Event

      Show object example
      {
        "name": "",
        "time": "0001-01-01T00:00:00Z",
        "identifiers": [],
        "data": null,
        "correlation_ids": [],
        "origin": "",
        "context": {},
        "visibility": {},
        "authentication": {},
        "remote_ip": "",
        "user_agent": "",
        "unique_id": "",
      }

      Fields:

      Field name
      Type string
      Description

      Name of the event. This can be used to find the (localized) event description.

      Field time
      Type google.protobuf. Timestamp
      Description

      Time at which the event was triggered.

      required

      Field identifiers
      Type repeated EntityIdentifiers
      Description

      Identifiers of the entity (or entities) involved.

      Field data
      Type google.protobuf. Any
      Description

      Optional data attached to the event.

      Field correlation_ids
      Type repeated string
      Description

      Correlation IDs can be used to find related events and actions such as API calls.

      max_len: 100

      Field origin
      Type string
      Description

      The origin of the event. Typically the hostname of the server that created it.

      Field context
      Type map of string to bytes
      Description

      Event context, internal use only.

      Field visibility
      Type Rights
      Description

      The event will be visible to a caller that has any of these rights.

      Field authentication
      Type Event.Authentication
      Description

      Details on the authentication provided by the caller that triggered this event.

      Field remote_ip
      Type string
      Description

      The IP address of the caller that triggered this event.

      Field user_agent
      Type string
      Description

      The IP address of the caller that triggered this event.

      Field unique_id
      Type string
      Description

      The unique identifier of the event, assigned on creation.

      Message Event.Authentication

      Show object example
      {
        "type": "",
        "token_type": "",
        "token_id": "",
      }

      Fields:

      Field type
      Type string
      Description

      The type of authentication that was used. This is typically a bearer token.

      Field token_type
      Type string
      Description

      The type of token that was used. Common types are APIKey, AccessToken and SessionToken.

      Field token_id
      Type string
      Description

      The ID of the token that was used.

      Message StreamEventsRequest

      Show object example
      {
        "identifiers": [],
        "tail": 0,
        "after": "0001-01-01T00:00:00Z",
        "names": [],
      }

      Fields:

      Field identifiers
      Type repeated EntityIdentifiers
      Description
      Field tail
      Type uint32
      Description

      If greater than zero, this will return historical events, up to this maximum when the stream starts. If used in combination with “after”, the limit that is reached first, is used. The availability of historical events depends on server support and retention policy.

      Field after
      Type google.protobuf. Timestamp
      Description

      If not empty, this will return historical events after the given time when the stream starts. If used in combination with “tail”, the limit that is reached first, is used. The availability of historical events depends on server support and retention policy.

      Field names
      Type repeated string
      Description

      If provided, this will filter events, so that only events with the given names are returned. Names can be provided as either exact event names (e.g. ‘gs.up.receive’), or as regular expressions (e.g. ‘/^gs..+/’).

      Message Rights

      Show object example
      {
        "rights": [],
      }

      Fields:

      Field rights
      Type repeated Right
      Description

      defined_only

      Enums

      Enum Right

      Right is the enum that defines all the different rights to do something in the network.

      Name Value Description
      right_invalid 0
      RIGHT_USER_INFO 1 The right to view user information.
      RIGHT_USER_SETTINGS_BASIC 2 The right to edit basic user settings.
      RIGHT_USER_LIST 87 The right to list users accounts.
      RIGHT_USER_CREATE 88 The right to create an user account.
      RIGHT_USER_SETTINGS_API_KEYS 3 The right to view and edit user API keys.
      RIGHT_USER_DELETE 4 The right to delete user account.
      RIGHT_USER_PURGE 66 The right to purge user account.
      RIGHT_USER_AUTHORIZED_CLIENTS 5 The right to view and edit authorized OAuth clients of the user.
      RIGHT_USER_APPLICATIONS_LIST 6 The right to list applications the user is a collaborator of.
      RIGHT_USER_APPLICATIONS_CREATE 7 The right to create an application under the user account.
      RIGHT_USER_GATEWAYS_LIST 8 The right to list gateways the user is a collaborator of.
      RIGHT_USER_GATEWAYS_CREATE 9 The right to create a gateway under the account of the user.
      RIGHT_USER_CLIENTS_LIST 10 The right to list OAuth clients the user is a collaborator of.
      RIGHT_USER_CLIENTS_CREATE 11 The right to create an OAuth client under the account of the user.
      RIGHT_USER_ORGANIZATIONS_LIST 12 The right to list organizations the user is a member of.
      RIGHT_USER_ORGANIZATIONS_CREATE 13 The right to create an organization under the user account.
      RIGHT_USER_NOTIFICATIONS_READ 59 The right to read notifications sent to the user.
      RIGHT_USER_ALL 14 The pseudo-right for all (current and future) user rights.
      RIGHT_APPLICATION_INFO 15 The right to view application information.
      RIGHT_APPLICATION_SETTINGS_BASIC 16 The right to edit basic application settings.
      RIGHT_APPLICATION_SETTINGS_API_KEYS 17 The right to view and edit application API keys.
      RIGHT_APPLICATION_SETTINGS_COLLABORATORS 18 The right to view and edit application collaborators.
      RIGHT_APPLICATION_SETTINGS_PACKAGES 56 The right to view and edit application packages and associations.
      RIGHT_APPLICATION_DELETE 19 The right to delete application.
      RIGHT_APPLICATION_PURGE 64 The right to purge application.
      RIGHT_APPLICATION_DEVICES_READ 20 The right to view devices in application.
      RIGHT_APPLICATION_DEVICES_WRITE 21 The right to create devices in application.
      RIGHT_APPLICATION_DEVICES_READ_KEYS 22 The right to view device keys in application. Note that keys may not be stored in a way that supports viewing them.
      RIGHT_APPLICATION_DEVICES_WRITE_KEYS 23 The right to edit device keys in application.
      RIGHT_APPLICATION_TRAFFIC_READ 24 The right to read application traffic (uplink and downlink).
      RIGHT_APPLICATION_TRAFFIC_UP_WRITE 25 The right to write uplink application traffic.
      RIGHT_APPLICATION_TRAFFIC_DOWN_WRITE 26 The right to write downlink application traffic.
      RIGHT_APPLICATION_LINK 27 The right to link as Application to a Network Server for traffic exchange, i.e. read uplink and write downlink (API keys only). This right is typically only given to an Application Server. This right implies RIGHT_APPLICATION_INFO, RIGHT_APPLICATION_TRAFFIC_READ, and RIGHT_APPLICATION_TRAFFIC_DOWN_WRITE.
      RIGHT_APPLICATION_ALL 28 The pseudo-right for all (current and future) application rights.
      RIGHT_CLIENT_ALL 29 The pseudo-right for all (current and future) OAuth client rights.
      RIGHT_CLIENT_INFO 60 The right to read client information.
      RIGHT_CLIENT_SETTINGS_BASIC 61 The right to edit basic client settings.
      RIGHT_CLIENT_SETTINGS_COLLABORATORS 62 The right to view and edit client collaborators.
      RIGHT_CLIENT_DELETE 63 The right to delete a client.
      RIGHT_CLIENT_PURGE 68 The right to purge a client.
      RIGHT_GATEWAY_INFO 30 The right to view gateway information.
      RIGHT_GATEWAY_SETTINGS_BASIC 31 The right to edit basic gateway settings.
      RIGHT_GATEWAY_SETTINGS_API_KEYS 32 The right to view and edit gateway API keys.
      RIGHT_GATEWAY_SETTINGS_COLLABORATORS 33 The right to view and edit gateway collaborators.
      RIGHT_GATEWAY_DELETE 34 The right to delete gateway.
      RIGHT_GATEWAY_PURGE 67 The right to purge gateway.
      RIGHT_GATEWAY_TRAFFIC_READ 35 The right to read gateway traffic.
      RIGHT_GATEWAY_TRAFFIC_DOWN_WRITE 36 The right to write downlink gateway traffic.
      RIGHT_GATEWAY_LINK 37 The right to link as Gateway to a Gateway Server for traffic exchange, i.e. write uplink and read downlink (API keys only) This right is typically only given to a gateway. This right implies RIGHT_GATEWAY_INFO.
      RIGHT_GATEWAY_STATUS_READ 38 The right to view gateway status.
      RIGHT_GATEWAY_LOCATION_READ 39 The right to view view gateway location.
      RIGHT_GATEWAY_WRITE_SECRETS 57 The right to store secrets associated with this gateway.
      RIGHT_GATEWAY_READ_SECRETS 58 The right to retrieve secrets associated with this gateway.
      RIGHT_GATEWAY_ALL 40 The pseudo-right for all (current and future) gateway rights.
      RIGHT_ORGANIZATION_INFO 41 The right to view organization information.
      RIGHT_ORGANIZATION_SETTINGS_BASIC 42 The right to edit basic organization settings.
      RIGHT_ORGANIZATION_SETTINGS_API_KEYS 43 The right to view and edit organization API keys.
      RIGHT_ORGANIZATION_SETTINGS_MEMBERS 44 The right to view and edit organization members.
      RIGHT_ORGANIZATION_DELETE 45 The right to delete organization.
      RIGHT_ORGANIZATION_PURGE 65 The right to purge organization.
      RIGHT_ORGANIZATION_APPLICATIONS_LIST 46 The right to list the applications the organization is a collaborator of.
      RIGHT_ORGANIZATION_APPLICATIONS_CREATE 47 The right to create an application under the organization.
      RIGHT_ORGANIZATION_GATEWAYS_LIST 48 The right to list the gateways the organization is a collaborator of.
      RIGHT_ORGANIZATION_GATEWAYS_CREATE 49 The right to create a gateway under the organization.
      RIGHT_ORGANIZATION_CLIENTS_LIST 50 The right to list the OAuth clients the organization is a collaborator of.
      RIGHT_ORGANIZATION_CLIENTS_CREATE 51 The right to create an OAuth client under the organization.
      RIGHT_ORGANIZATION_ADD_AS_COLLABORATOR 52 The right to add the organization as a collaborator on an existing entity.
      RIGHT_ORGANIZATION_ALL 53 The pseudo-right for all (current and future) organization rights.
      RIGHT_SEND_INVITES 54 The right to send invites to new users. Note that this is not prefixed with “USER_”; it is not a right on the user entity.
      RIGHT_ALERT_NOTIFICATION_PROFILE_CREATE 69 The right to create an alert notification profile.
      RIGHT_ALERT_NOTIFICATION_PROFILE_INFO 70 The right to view an alert notification profile information.
      RIGHT_ALERT_NOTIFICATION_PROFILE_LIST 71 The right to list the alert notification profiles.
      RIGHT_ALERT_NOTIFICATION_PROFILE_UPDATE 72 The right to update an alert notification profiles.
      RIGHT_ALERT_NOTIFICATION_PROFILE_DELETE 73 The right to delete an alert notification profiles.
      RIGHT_ALERT_NOTIFICATION_RECEIVER_CREATE 74 The right to create an alert notification receiver.
      RIGHT_ALERT_NOTIFICATION_RECEIVER_INFO 75 The right to view an alert notification receiver information.
      RIGHT_ALERT_NOTIFICATION_RECEIVER_LIST 76 The right to list the alert notification receivers.
      RIGHT_ALERT_NOTIFICATION_RECEIVER_UPDATE 77 The right to update an alert notification receivers.
      RIGHT_ALERT_NOTIFICATION_RECEIVER_DELETE 78 The right to delete an alert notification receivers.
      RIGHT_AUTHENTICATION_PROVIDER_CREATE 79 The right to create an authentication provider.
      RIGHT_AUTHENTICATION_PROVIDER_INFO 80 The right to view an authentication provider information.
      RIGHT_AUTHENTICATION_PROVIDER_LIST 81 The right to list the authentication providers
      RIGHT_AUTHENTICATION_PROVIDER_UPDATE 82 The right to update an authentication providers.
      RIGHT_AUTHENTICATION_PROVIDER_DELETE 83 The right to delete an authentication providers.
      RIGHT_EXTERNAL_USER_CREATE 84 The right to create an external user.
      RIGHT_EXTERNAL_USER_INFO 85 The right to view an external user’s information.
      RIGHT_EXTERNAL_USER_DELETE 86 The right to delete an external user.
      RIGHT_PACKET_BROKER_AGENT_READ 89 The right to read any information related to the PBA.
      RIGHT_PACKET_BROKER_AGENT_WRITE 90 The right to perform operations in the PBA.
      RIGHT_TENANT_CONFIGURATION_UPDATE 91 The right to update a tenant’s configuration.
      RIGHT_LABEL_CREATE 92 The right to create a label.
      RIGHT_LABEL_INFO 93 The right to view a label’s information.
      RIGHT_LABELS_LIST 94 The right to list the labels.
      RIGHT_LABEL_UPDATE 95 The right to update a label.
      RIGHT_LABEL_DELETE 96 The right to delete a label.
      RIGHT_LABEL_ASSIGN 97 The right to assign a label to an entity.
      RIGHT_LABEL_ALL 99
      RIGHT_ALL 55 The pseudo-right for all (current and future) possible rights.

      Events

      Event account.user.login_failed

      login user failure

      Event application.api-key.create

      create application API key

      Event application.api-key.delete

      delete application API key

      Event application.api-key.update

      update application API key

      Event application.collaborator.delete

      delete application collaborator

      Event application.collaborator.update

      update application collaborator

      Event application.create

      create application

      Event application.delete

      delete application

      Event application.issue_dev_eui

      issue DevEUI for application

      Event application.purge

      purge application

      Event application.restore

      restore application

      Event application.update

      update application

      Show example of data field
      {
        "@type": "type.googleapis.com/google.protobuf.Value",
        "value": [
          "list.of",
          "updated.fields"
        ]
      }

      Event as.application.subscribe

      subscribe application

      Event as.application.unsubscribe

      unsubscribe application

      Event as.down.data.decode.fail

      decode downlink data message failure

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.ErrorDetails",
        "attributes": {
          "attr_name": "attr_value"
        },
        "code": 2,
        "message_format": "example error for `{attr_name}`",
        "name": "example",
        "namespace": "pkg/example"
      }

      Event as.down.data.decode.warning

      decode downlink data message warning

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.ApplicationDownlink"
      }

      Event as.down.data.drop

      drop downlink data message

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.ErrorDetails",
        "attributes": {
          "attr_name": "attr_value"
        },
        "code": 2,
        "message_format": "example error for `{attr_name}`",
        "name": "example",
        "namespace": "pkg/example"
      }

      Event as.down.data.encode.fail

      encode downlink data message failure

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.ErrorDetails",
        "attributes": {
          "attr_name": "attr_value"
        },
        "code": 2,
        "message_format": "example error for `{attr_name}`",
        "name": "example",
        "namespace": "pkg/example"
      }

      Event as.down.data.encode.warning

      encode downlink data message warning

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.ApplicationDownlink"
      }

      Event as.down.data.forward

      forward downlink data message

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.ApplicationDownlink"
      }

      Event as.down.data.receive

      receive downlink data message

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.ApplicationDownlink"
      }

      Event as.end_device.batch.delete

      batch delete end devices

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.EndDeviceIdentifiersList"
      }

      Event as.end_device.create

      create end device

      Event as.end_device.delete

      delete end device

      Event as.end_device.update

      update end device

      Show example of data field
      {
        "@type": "type.googleapis.com/google.protobuf.Value",
        "value": [
          "list.of",
          "updated.fields"
        ]
      }

      Event as.mqtt.connect.fail

      fail to connect to MQTT

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.ErrorDetails",
        "attributes": {
          "attr_name": "attr_value"
        },
        "code": 2,
        "message_format": "example error for `{attr_name}`",
        "name": "example",
        "namespace": "pkg/example"
      }

      Event as.packages.alcsync.v1.fail

      package failed due to error

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.ErrorDetails",
        "attributes": {
          "attr_name": "attr_value"
        },
        "code": 2,
        "message_format": "example error for `{attr_name}`",
        "name": "example",
        "namespace": "pkg/example"
      }

      Event as.packages.alcsync.v1.time_correction.answer_enqueued

      time correction command answer enqueued

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.ALCSyncCommand.AppTimeAns"
      }

      Event as.packages.alcsync.v1.time_correction.cmd_received

      time correction command received

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.ALCSyncCommand.AppTimeReq"
      }

      Event as.packages.awsiot.fail

      fail to process upstream message

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.ErrorDetails",
        "attributes": {
          "attr_name": "attr_value"
        },
        "code": 2,
        "message_format": "example error for `{attr_name}`",
        "name": "example",
        "namespace": "pkg/example"
      }

      Event as.packages.azure.iotcentral.fail

      fail to process upstream message

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.ErrorDetails",
        "attributes": {
          "attr_name": "attr_value"
        },
        "code": 2,
        "message_format": "example error for `{attr_name}`",
        "name": "example",
        "namespace": "pkg/example"
      }

      Event as.packages.azure.iothub.fail

      fail to process upstream message

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.ErrorDetails",
        "attributes": {
          "attr_name": "attr_value"
        },
        "code": 2,
        "message_format": "example error for `{attr_name}`",
        "name": "example",
        "namespace": "pkg/example"
      }

      Event as.packages.loraclouddmsv1.fail

      fail to process upstream message

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.ErrorDetails",
        "attributes": {
          "attr_name": "attr_value"
        },
        "code": 2,
        "message_format": "example error for `{attr_name}`",
        "name": "example",
        "namespace": "pkg/example"
      }

      Event as.packages.loracloudglsv3.fail

      fail to process upstream message

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.ErrorDetails",
        "attributes": {
          "attr_name": "attr_value"
        },
        "code": 2,
        "message_format": "example error for `{attr_name}`",
        "name": "example",
        "namespace": "pkg/example"
      }

      Event as.packages.storage.up.drop

      drop upstream data message

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.ErrorDetails",
        "attributes": {
          "attr_name": "attr_value"
        },
        "code": 2,
        "message_format": "example error for `{attr_name}`",
        "name": "example",
        "namespace": "pkg/example"
      }

      Event as.packages.storage.up.store

      store upstream data message

      Event as.pubsub.delete

      delete pub/sub

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.ApplicationPubSubIdentifiers",
        "application_ids": {
          "application_id": "application-id"
        },
        "pub_sub_id": "pubsub-id"
      }

      Event as.pubsub.fail

      fail pub/sub

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.ErrorDetails",
        "attributes": {
          "attr_name": "attr_value"
        },
        "code": 2,
        "message_format": "example error for `{attr_name}`",
        "name": "example",
        "namespace": "pkg/example"
      }

      Event as.pubsub.set

      set pub/sub

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.ApplicationPubSubIdentifiers",
        "application_ids": {
          "application_id": "application-id"
        },
        "pub_sub_id": "pubsub-id"
      }

      Event as.pubsub.start

      start pub/sub

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.ApplicationPubSubIdentifiers",
        "application_ids": {
          "application_id": "application-id"
        },
        "pub_sub_id": "pubsub-id"
      }

      Event as.pubsub.stop

      stop pub/sub

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.ApplicationPubSubIdentifiers",
        "application_ids": {
          "application_id": "application-id"
        },
        "pub_sub_id": "pubsub-id"
      }

      Event as.up.data.decode.fail

      decode uplink data message failure

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.ErrorDetails",
        "attributes": {
          "attr_name": "attr_value"
        },
        "code": 2,
        "message_format": "example error for `{attr_name}`",
        "name": "example",
        "namespace": "pkg/example"
      }

      Event as.up.data.decode.warning

      decode uplink data message warning

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.ApplicationUplink"
      }

      Event as.up.data.drop

      drop uplink data message

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.ErrorDetails",
        "attributes": {
          "attr_name": "attr_value"
        },
        "code": 2,
        "message_format": "example error for `{attr_name}`",
        "name": "example",
        "namespace": "pkg/example"
      }

      Event as.up.data.forward

      forward uplink data message

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.ApplicationUp"
      }

      Event as.up.data.normalize.warning

      normalize uplink data message warning

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.ApplicationUplink"
      }

      Event as.up.data.receive

      receive uplink data message

      Event as.up.join.drop

      drop join-accept message

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.ErrorDetails",
        "attributes": {
          "attr_name": "attr_value"
        },
        "code": 2,
        "message_format": "example error for `{attr_name}`",
        "name": "example",
        "namespace": "pkg/example"
      }

      Event as.up.join.forward

      forward join-accept message

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.ApplicationUp"
      }

      Event as.up.join.receive

      receive join-accept message

      Event as.up.location.forward

      forward location solved message

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.ApplicationUp"
      }

      Event as.up.normalized.forward

      forward normalized uplink message

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.ApplicationUp"
      }

      Event as.up.service.forward

      forward service data message

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.ApplicationUp"
      }

      Event as.webhook.fail

      fail to send webhook

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.ErrorDetails",
        "attributes": {
          "attr_name": "attr_value"
        },
        "code": 2,
        "message_format": "example error for `{attr_name}`",
        "name": "example",
        "namespace": "pkg/example"
      }

      Event client.collaborator.delete

      delete client collaborator

      Event client.collaborator.update

      update client collaborator

      Event client.create

      create OAuth client

      Event client.delete

      delete OAuth client

      Event client.purge

      purge client

      Event client.restore

      restore OAuth client

      Event client.update

      update OAuth client

      Show example of data field
      {
        "@type": "type.googleapis.com/google.protobuf.Value",
        "value": [
          "list.of",
          "updated.fields"
        ]
      }

      Event dcs.end_device.claim.abort

      abort end device claim

      Event dcs.end_device.claim.fail

      claim end device failure

      Event dcs.end_device.claim.success

      claim end device successful

      Event dcs.gateway.claim.abort

      abort gateway claim

      Event dcs.gateway.claim.fail

      claim gateway failure

      Event dcs.gateway.claim.success

      claim gateway successful

      Event end_device.batch.delete

      batch delete end devices

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.EndDeviceIdentifiersList"
      }

      Event end_device.create

      create end device

      Event end_device.delete

      delete end device

      Event end_device.update

      update end device

      Show example of data field
      {
        "@type": "type.googleapis.com/google.protobuf.Value",
        "value": [
          "list.of",
          "updated.fields"
        ]
      }

      Event gateway.api-key.create

      create gateway API key

      Event gateway.api-key.delete

      delete gateway API key

      Event gateway.api-key.update

      update gateway API key

      Event gateway.batch.delete

      batch delete gateways

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.GatewayIdentifiersList"
      }

      Event gateway.collaborator.delete

      delete gateway collaborator

      Event gateway.collaborator.update

      update gateway collaborator

      Event gateway.create

      create gateway

      Event gateway.delete

      delete gateway

      Event gateway.purge

      purge gateway

      Event gateway.restore

      restore gateway

      Event gateway.update

      update gateway

      Show example of data field
      {
        "@type": "type.googleapis.com/google.protobuf.Value",
        "value": [
          "list.of",
          "updated.fields"
        ]
      }

      Event gs.down.schedule.attempt

      schedule downlink for transmission by gateway

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.DownlinkMessage"
      }

      Event gs.down.schedule.fail

      schedule downlink for transmission by gateway

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.ErrorDetails",
        "attributes": {
          "attr_name": "attr_value"
        },
        "code": 2,
        "message_format": "example error for `{attr_name}`",
        "name": "example",
        "namespace": "pkg/example"
      }

      Event gs.down.send

      send downlink message

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.DownlinkMessage"
      }

      Event gs.down.tx.fail

      transmit downlink message failure

      Show example of data field
      {
        "@type": "type.googleapis.com/google.protobuf.Value",
        "value": 4
      }

      Event gs.down.tx.success

      transmit downlink message successful

      Event gs.gateway.connect

      connect gateway

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.GatewayConnectionStats"
      }

      Event gs.gateway.connection.stats

      gateway connection statistics

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.GatewayConnectionStats"
      }

      Event gs.gateway.disconnect

      disconnect gateway

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.ErrorDetails",
        "attributes": {
          "attr_name": "attr_value"
        },
        "code": 2,
        "message_format": "example error for `{attr_name}`",
        "name": "example",
        "namespace": "pkg/example"
      }

      Event gs.io.status.drop

      drop gateway status

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.ErrorDetails",
        "attributes": {
          "attr_name": "attr_value"
        },
        "code": 2,
        "message_format": "example error for `{attr_name}`",
        "name": "example",
        "namespace": "pkg/example"
      }

      Event gs.io.tx.ack.drop

      drop tx ack message

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.ErrorDetails",
        "attributes": {
          "attr_name": "attr_value"
        },
        "code": 2,
        "message_format": "example error for `{attr_name}`",
        "name": "example",
        "namespace": "pkg/example"
      }

      Event gs.io.up.drop

      drop uplink message

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.ErrorDetails",
        "attributes": {
          "attr_name": "attr_value"
        },
        "code": 2,
        "message_format": "example error for `{attr_name}`",
        "name": "example",
        "namespace": "pkg/example"
      }

      Event gs.io.up.repeat

      received repeated uplink message from gateway

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.GatewayIdentifiers"
      }

      Event gs.status.drop

      drop gateway status

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.ErrorDetails",
        "attributes": {
          "attr_name": "attr_value"
        },
        "code": 2,
        "message_format": "example error for `{attr_name}`",
        "name": "example",
        "namespace": "pkg/example"
      }

      Event gs.status.receive

      receive gateway status

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.GatewayStatus"
      }

      Event gs.txack.drop

      drop transmission acknowledgement

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.ErrorDetails",
        "attributes": {
          "attr_name": "attr_value"
        },
        "code": 2,
        "message_format": "example error for `{attr_name}`",
        "name": "example",
        "namespace": "pkg/example"
      }

      Event gs.txack.forward

      forward transmission acknowledgement

      Event gs.txack.receive

      receive transmission acknowledgement

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.TxAcknowledgment"
      }

      Event gs.up.drop

      drop uplink message

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.ErrorDetails",
        "attributes": {
          "attr_name": "attr_value"
        },
        "code": 2,
        "message_format": "example error for `{attr_name}`",
        "name": "example",
        "namespace": "pkg/example"
      }

      Event gs.up.forward

      forward uplink message

      Event gs.up.receive

      receive uplink message

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.GatewayUplinkMessage"
      }

      Event invitation.create

      create invitation

      Event js.end_device.batch.delete

      batch delete end devices

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.EndDeviceIdentifiersList"
      }

      Event js.end_device.create

      create end device

      Event js.end_device.delete

      delete end device

      Event js.end_device.update

      update end device

      Show example of data field
      {
        "@type": "type.googleapis.com/google.protobuf.Value",
        "value": [
          "list.of",
          "updated.fields"
        ]
      }

      Event js.join.accept

      accept join-request

      Event js.join.reject

      reject join-request

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.ErrorDetails",
        "attributes": {
          "attr_name": "attr_value"
        },
        "code": 2,
        "message_format": "example error for `{attr_name}`",
        "name": "example",
        "namespace": "pkg/example"
      }

      Event ns.class.switch.a

      switched to class A

      Event ns.class.switch.b

      switched to class B

      Event ns.class.switch.c

      switched to class C

      Event ns.down.data.schedule.attempt

      schedule data downlink for transmission on Gateway Server

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.DownlinkMessage"
      }

      Event ns.down.data.schedule.fail

      schedule data downlink for transmission on Gateway Server

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.ErrorDetails",
        "attributes": {
          "attr_name": "attr_value"
        },
        "code": 2,
        "message_format": "example error for `{attr_name}`",
        "name": "example",
        "namespace": "pkg/example"
      }

      Event ns.down.data.schedule.success

      successfully scheduled data downlink for transmission on Gateway Server

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.ScheduleDownlinkResponse"
      }

      Event ns.down.join.schedule.attempt

      schedule join-accept for transmission on Gateway Server

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.DownlinkMessage"
      }

      Event ns.down.join.schedule.fail

      schedule join-accept for transmission on Gateway Server

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.ErrorDetails",
        "attributes": {
          "attr_name": "attr_value"
        },
        "code": 2,
        "message_format": "example error for `{attr_name}`",
        "name": "example",
        "namespace": "pkg/example"
      }

      Event ns.down.join.schedule.success

      successfully scheduled join-accept for transmission on Gateway Server

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.ScheduleDownlinkResponse"
      }

      Event ns.down.rx.parameters.fail

      compute RX parameters

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.ErrorDetails",
        "attributes": {
          "attr_name": "attr_value"
        },
        "code": 2,
        "message_format": "example error for `{attr_name}`",
        "name": "example",
        "namespace": "pkg/example"
      }

      Event ns.down.transmission.fail

      transmit downlink

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.ErrorDetails",
        "attributes": {
          "attr_name": "attr_value"
        },
        "code": 2,
        "message_format": "example error for `{attr_name}`",
        "name": "example",
        "namespace": "pkg/example"
      }

      Event ns.down.transmission.success

      downlink successfully transmitted

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.DownlinkMessage"
      }

      Event ns.end_device.batch.delete

      batch delete end devices

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.EndDeviceIdentifiersList"
      }

      Event ns.end_device.create

      create end device

      Event ns.end_device.delete

      delete end device

      Event ns.end_device.update

      update end device

      Show example of data field
      {
        "@type": "type.googleapis.com/google.protobuf.Value",
        "value": [
          "list.of",
          "updated.fields"
        ]
      }

      Event ns.mac.adr_param_setup.answer

      ADR parameter setup answer received

      Event ns.mac.adr_param_setup.request

      ADR parameter setup request enqueued

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.MACCommand.ADRParamSetupReq"
      }

      Event ns.mac.beacon_freq.answer.accept

      beacon frequency change accept received

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.MACCommand.BeaconFreqAns"
      }

      Event ns.mac.beacon_freq.answer.reject

      beacon frequency change rejection received

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.MACCommand.BeaconFreqAns"
      }

      Event ns.mac.beacon_freq.request

      beacon frequency change request enqueued

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.MACCommand.BeaconFreqReq"
      }

      Event ns.mac.command.parse.fail

      parse MAC command

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.ErrorDetails",
        "attributes": {
          "attr_name": "attr_value"
        },
        "code": 2,
        "message_format": "example error for `{attr_name}`",
        "name": "example",
        "namespace": "pkg/example"
      }

      Event ns.mac.command.process.fail

      process MAC command

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.ErrorDetails",
        "attributes": {
          "attr_name": "attr_value"
        },
        "code": 2,
        "message_format": "example error for `{attr_name}`",
        "name": "example",
        "namespace": "pkg/example"
      }

      Event ns.mac.command.unanswered

      MAC command answer missing

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.MACCommands"
      }

      Event ns.mac.command.unknown

      unknown MAC command

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.MACCommand"
      }

      Event ns.mac.dev_status.answer

      device status answer received

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.MACCommand.DevStatusAns"
      }

      Event ns.mac.dev_status.request

      device status request enqueued

      Event ns.mac.device_mode.confirmation

      device mode confirmation enqueued

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.MACCommand.DeviceModeConf"
      }

      Event ns.mac.device_mode.indication

      device mode indication received

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.MACCommand.DeviceModeInd"
      }

      Event ns.mac.device_time.answer

      device time answer enqueued

      Event ns.mac.device_time.request

      device time request received

      Event ns.mac.dl_channel.answer.accept

      downlink Rx1 channel frequency modification accept received

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.MACCommand.DLChannelAns"
      }

      Event ns.mac.dl_channel.answer.reject

      downlink Rx1 channel frequency modification rejection received

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.MACCommand.DLChannelAns"
      }

      Event ns.mac.dl_channel.request

      downlink Rx1 channel frequency modification request enqueued

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.MACCommand.DLChannelReq"
      }

      Event ns.mac.duty_cycle.answer

      maximum aggregated transmit duty-cycle change answer received

      Event ns.mac.duty_cycle.request

      maximum aggregated transmit duty-cycle change request enqueued

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.MACCommand.DutyCycleReq"
      }

      Event ns.mac.force_rejoin.request

      force rejoin request enqueued

      Event ns.mac.link_adr.answer.accept

      link ADR accept received

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.MACCommand.LinkADRAns"
      }

      Event ns.mac.link_adr.answer.reject

      link ADR rejection received

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.MACCommand.LinkADRAns"
      }

      Event ns.mac.link_adr.request

      link ADR request enqueued

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.MACCommand.LinkADRReq"
      }

      Event ns.mac.link_check.answer

      link check answer enqueued

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.MACCommand.LinkCheckAns"
      }

      Event ns.mac.link_check.request

      link check request received

      Event ns.mac.new_channel.answer.accept

      new channel accept received

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.MACCommand.NewChannelAns"
      }

      Event ns.mac.new_channel.answer.reject

      new channel rejection received

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.MACCommand.NewChannelAns"
      }

      Event ns.mac.new_channel.request

      new channel request enqueued

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.MACCommand.NewChannelReq"
      }

      Event ns.mac.ping_slot_channel.answer.accept

      ping slot channel accept received

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.MACCommand.PingSlotChannelAns"
      }

      Event ns.mac.ping_slot_channel.answer.reject

      ping slot channel rejection received

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.MACCommand.PingSlotChannelAns"
      }

      Event ns.mac.ping_slot_channel.request

      ping slot channel request enqueued

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.MACCommand.PingSlotChannelReq"
      }

      Event ns.mac.ping_slot_info.answer

      ping slot info answer enqueued

      Event ns.mac.ping_slot_info.request

      ping slot info request received

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.MACCommand.PingSlotInfoReq"
      }

      Event ns.mac.proprietary.receive

      receive proprietary MAC command

      Event ns.mac.rejoin_param_setup.answer

      rejoin parameter setup answer received

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.MACCommand.RejoinParamSetupAns"
      }

      Event ns.mac.rejoin_param_setup.request

      rejoin parameter setup request enqueued

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.MACCommand.RejoinParamSetupReq"
      }

      Event ns.mac.rekey.confirmation

      device rekey confirmation enqueued

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.MACCommand.RekeyConf"
      }

      Event ns.mac.rekey.indication

      device rekey indication received

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.MACCommand.RekeyInd"
      }

      Event ns.mac.reset.confirmation

      device reset confirmation enqueued

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.MACCommand.ResetConf"
      }

      Event ns.mac.reset.indication

      device reset indication received

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.MACCommand.ResetInd"
      }

      Event ns.mac.rx_param_setup.answer.accept

      Rx parameter setup accept received

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.MACCommand.RxParamSetupAns"
      }

      Event ns.mac.rx_param_setup.answer.reject

      Rx parameter setup rejection received

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.MACCommand.RxParamSetupAns"
      }

      Event ns.mac.rx_param_setup.request

      Rx parameter setup request enqueued

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.MACCommand.RxParamSetupReq"
      }

      Event ns.mac.rx_timing_setup.answer

      Rx timing setup answer received

      Event ns.mac.rx_timing_setup.request

      Rx timing setup request enqueued

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.MACCommand.RxTimingSetupReq"
      }

      Event ns.mac.tx_param_setup.answer

      Tx parameter setup answer received

      Event ns.mac.tx_param_setup.request

      Tx parameter setup request enqueued

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.MACCommand.TxParamSetupReq"
      }

      Event ns.up.data.drop

      drop data message

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.ErrorDetails",
        "attributes": {
          "attr_name": "attr_value"
        },
        "code": 2,
        "message_format": "example error for `{attr_name}`",
        "name": "example",
        "namespace": "pkg/example"
      }

      Event ns.up.data.forward

      forward data message to Application Server

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.ApplicationUp",
        "uplink_message": {}
      }

      Event ns.up.data.process

      successfully processed data message

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.UplinkMessage"
      }

      Event ns.up.data.receive

      receive data message

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.UplinkMessage"
      }

      Event ns.up.join.accept.forward

      forward join-accept to Application Server

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.ApplicationUp",
        "join_accept": {}
      }

      Event ns.up.join.cluster.attempt

      send join-request to cluster-local Join Server

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.JoinRequest"
      }

      Event ns.up.join.cluster.fail

      join-request to cluster-local Join Server failed

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.ErrorDetails",
        "attributes": {
          "attr_name": "attr_value"
        },
        "code": 2,
        "message_format": "example error for `{attr_name}`",
        "name": "example",
        "namespace": "pkg/example"
      }

      Event ns.up.join.cluster.success

      join-request to cluster-local Join Server succeeded

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.JoinResponse"
      }

      Event ns.up.join.drop

      drop join-request

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.ErrorDetails",
        "attributes": {
          "attr_name": "attr_value"
        },
        "code": 2,
        "message_format": "example error for `{attr_name}`",
        "name": "example",
        "namespace": "pkg/example"
      }

      Event ns.up.join.interop.attempt

      forward join-request to interoperability Join Server

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.JoinRequest"
      }

      Event ns.up.join.interop.fail

      join-request to interoperability Join Server failed

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.ErrorDetails",
        "attributes": {
          "attr_name": "attr_value"
        },
        "code": 2,
        "message_format": "example error for `{attr_name}`",
        "name": "example",
        "namespace": "pkg/example"
      }

      Event ns.up.join.interop.success

      join-request to interoperability Join Server succeeded

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.JoinResponse"
      }

      Event ns.up.join.process

      successfully processed join-request

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.UplinkMessage"
      }

      Event ns.up.join.receive

      receive join-request

      Show example of data field
      {
        "@type": "type.googleapis.com/ttn.lorawan.v3.UplinkMessage"
      }

      Event oauth.authorize

      authorize OAuth client

      Event oauth.session.terminated

      terminate user session

      Event oauth.token.deleted

      delete access token

      Event oauth.token.exchange

      exchange OAuth access token

      Event oauth.user.login

      login user successful

      Event oauth.user.logout

      logout user

      Event organization.api-key.create

      create organization API key

      Event organization.api-key.delete

      delete organization API key

      Event organization.api-key.update

      update organization API key

      Event organization.collaborator.delete

      delete organization collaborator

      Event organization.collaborator.update

      update organization collaborator

      Event organization.create

      create organization

      Event organization.delete

      delete organization

      Event organization.purge

      purge organization

      Event organization.restore

      restore organization

      Event organization.update

      update organization

      Show example of data field
      {
        "@type": "type.googleapis.com/google.protobuf.Value",
        "value": [
          "list.of",
          "updated.fields"
        ]
      }

      Event user.api-key.create

      create user API key

      Event user.api-key.delete

      delete user API key

      Event user.api-key.update

      update user API key

      Event user.create

      create user

      Event user.delete

      delete user

      Event user.purge

      purge user

      Event user.restore

      restore user

      Event user.update

      update user

      Show example of data field
      {
        "@type": "type.googleapis.com/google.protobuf.Value",
        "value": [
          "list.of",
          "updated.fields"
        ]
      }

      Event user.update.incorrect_password

      update user failure: incorrect password

      ← End Device APIs Gateway APIs →

      On this page

      • The Events service
      • Messages
      • Enums
      • Events

      Sections

      Getting Started

      Concepts

      Cloud

      Enterprise

      Integrations

      API

      Hardware

      Sitemap

      View our Sitemap

      Contributing

      GitHub

      About Us

      The Things Industries

      Privacy Policy

      Cookie settings

      Cookie Settings

      We use cookies to enhance your experience, analyze site traffic and deliver personalized content. Read our Privacy Policy.

      Cookie categories